Object subclass:#Java
	instanceVariableNames:''
	classVariableNames:'Classes UnresolvedClassRefs'
	poolDictionaries:''
	category:'Java-Support'
!


!Java class methodsFor:'accessing'!

allClasses
    ^ Classes
!

classNamed:aString
    ^ self at:aString
! !

!Java class methodsFor:'registering java classes'!

at:aJavaName
    Classes isNil ifTrue:[^ nil].
    ^ Classes at:(aJavaName asSymbol) ifAbsent:nil

    "Created: 17.4.1996 / 23:29:46 / cg"
    "Modified: 18.4.1996 / 00:45:33 / cg"
!

at:aJavaName put:aJavaClass
    Classes isNil ifTrue:[
        Classes := IdentityDictionary new.
    ].
    Classes at:(aJavaName asSymbol) put:aJavaClass.

    UnresolvedClassRefs notNil ifTrue:[
        UnresolvedClassRefs do:[:toResolve |
        
        ]
    ].
    self changed:#classes

    "Created: 17.4.1996 / 23:29:31 / cg"
    "Modified: 18.4.1996 / 00:45:39 / cg"
!

flushClasses
    Classes := UnresolvedClassRefs := nil.

    "
     Java flushClasses
    "

    "Modified: 18.4.1996 / 00:20:23 / cg"
!

rememberUnresolved:anUnresolvedClassRef
    UnresolvedClassRefs isNil ifTrue:[
        UnresolvedClassRefs := OrderedCollection new.
    ].
    UnresolvedClassRefs add:anUnresolvedClassRef

    "Created: 18.4.1996 / 00:05:31 / cg"
    "Modified: 18.4.1996 / 00:05:41 / cg"
! !

!Java class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/Java.st,v 1.5 1996/05/02 15:19:44 cg Exp $'
! !
